#include "dialogselectpoints.h"
#include "ui_dialogselectpoints.h"
#include "mouseeventfilter.h"
#include "qtcvtransform.h"

DialogSelectPoints::DialogSelectPoints(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogSelectPoints)
{
    ui->setupUi(this);
}

void::DialogSelectPoints::init(SelectPoint *p) {
    this->p = p;
    this->p->setDialog(ui);
    ui->pushButtonClose->setGeometry(QRect( this->p->getWidth() - 100, this->p->getHeight()+20, 83, 25));
    ui->pushButtonCompute->setGeometry(QRect( this->p->getWidth() - 200, this->p->getHeight()+20, 83, 25));
    ui->pushButtonCancelAll->setGeometry(QRect( this->p->getWidth() - 300, this->p->getHeight()+20, 83, 25));
    ui->pushButtonCancelLast->setGeometry(QRect( this->p->getWidth() - 400, this->p->getHeight()+20, 83, 25));
    ui->labelMsg->setGeometry(QRect(10, this->p->getHeight()+20, 600, 16));
    ui->labelMsg->setText("Select Minimum four (4) points and then press Compute!: Select a Point from the Object View");
    ui->labelImage->setGeometry(QRect(10, 10, this->p->getWidth(), this->p->getHeight()));
    QImage *tmpImg = Mat2QImage(this->p->getCompleteImage());
    QPixmap image = QPixmap::fromImage(*tmpImg);
    ui->labelImage->setPixmap(image);
    delete tmpImg;
    ui->labelImage->installEventFilter(new mouseEventFilter(this->p, ui));
    ui->pushButtonCompute->setStyleSheet("color: rgb(120, 120, 120); color: rgb(120, 120, 120)");
    connect(ui->pushButtonClose, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect(ui->pushButtonCancelAll, SIGNAL( clicked() ), this, SLOT( resetAll() ) );
    connect(ui->pushButtonCancelLast, SIGNAL( clicked() ), this, SLOT( resetLast() ) );
    connect(ui->pushButtonCompute, SIGNAL( clicked() ), this, SLOT( compute() )  );

}

DialogSelectPoints::~DialogSelectPoints() {
    delete ui;
}

void DialogSelectPoints::setKinect(std::string objName, std::string sceneName) {
    this->objName = objName;
    this->sceneName = sceneName;
    p->setNames(objName, sceneName);
}

void DialogSelectPoints::resetAll() {
    p->resetPoint();
}

void DialogSelectPoints::resetLast() {
    p->resetLastPoint();
}

void DialogSelectPoints::compute() {
    p->compute();
}


