#ifndef SELECTPOINT_H
#define SELECTPOINT_H

#include "opencv2/opencv.hpp"
#include <vector>
#include <QImage>
#include <sstream>
#include "ui_dialogselectpoints.h"
#include "homography.hpp"

class SelectPoint
{
    public:
        SelectPoint();
        SelectPoint(const std::string, const QImage *, int num);
        void mouseCallback();
        void getSetPoints(std::vector<cv::Point> &, std::vector<cv::Point> &);
        void setNames(std::string, std::string);
        void changeState(int x, int y);
        int getWidth();
        int getHeight();
        void setDialog(Ui::DialogSelectPoints *ui) { dialog = ui; };
        void resetPoint();
        void resetLastPoint();
        cv::Mat getCompleteImage() { return img_complete; };
        cv::Mat getHomography() { return H.clone(); };
        void compute();
        virtual ~SelectPoint();
    private:
        bool isPossibleToCompute;
        cv::Mat H;
        Homography *h;
        cv::Mat img_obj;
        cv::Mat img_scene;
        cv::Mat img_complete;
        cv::Mat img_complete_clone;
        std::string objName;
        std::string filename;
        std::vector<cv::Point2f> obj_points;
        std::vector<cv::Point2f> scene_points;
        Ui::DialogSelectPoints *dialog;
};

#endif // SELECTPOINT_H
